// FileMapper.h: interface for the FileMapper class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FILEMAPPER_H__A01B2D92_6DBC_44EF_983F_B7B19708EFD9__INCLUDED_)
#define AFX_FILEMAPPER_H__A01B2D92_6DBC_44EF_983F_B7B19708EFD9__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "../Framework/Platform.h"
#if defined(WIN32)
#include <windows.h>
#else
#include <sys/types.h>
#endif


class FileMapper  
{
public:
	FileMapper();
	~FileMapper();

	bool open( const char* file_name, size_t length, size_t start=0);
	void close();
	void* getMapped() { return m_mapped; }

private:
	size_t m_start;
	size_t m_length;
	void* m_mapped;
#if defined(WIN32)
	HANDLE m_hFile;
	HANDLE m_hMapping;
#else
	int m_fd;
#endif
};

#endif // !defined(AFX_FILEMAPPER_H__A01B2D92_6DBC_44EF_983F_B7B19708EFD9__INCLUDED_)
